package org.xbib.net.http.client.netty.test;

import org.junit.jupiter.api.Test;
import org.xbib.net.URL;
import org.xbib.net.http.client.netty.HttpRequest;

import java.util.Map;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class ParameterTest {

    public ParameterTest() {
    }

    @Test
    public void testGetParametersWithSharedUrl() {
        URL url = URL.from("http://example.com");
        Map<String, Object> map1 = Map.of("a", "b");
        HttpRequest request1 = HttpRequest.get()
                .setURL(url)
                .setParameters(map1)
                .build();
        assertEquals("http://example.com?a=b", request1.getURL().toString());
        Map<String, Object> map2 = Map.of("c", "d");
        HttpRequest request2 = HttpRequest.get()
                .setURL(url)
                .setParameters(map2)
                .build();
        assertEquals("http://example.com?c=d", request2.getURL().toString());
    }
}
