package org.xbib.net.http.j2html;

import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;

import java.io.IOException;
import java.nio.file.Path;

public class J2HtmlResourceHandler extends HtmlTemplateResourceHandler {

    public J2HtmlResourceHandler() {
        this(null, "java", "index.java");
    }

    public J2HtmlResourceHandler(Path root, String suffix, String indexFileName) {
        super(root, suffix, indexFileName);
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return httpRouterContext.isAuthenticated() ?
                new J2HtmlResource(this, httpRouterContext) :
                createUnauthenticatedResource(httpRouterContext);
    }

    protected Resource createUnauthenticatedResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return new J2HtmlResource(this, httpRouterContext);
    }
}
