package org.xbib.net.http.j2html;

import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.HttpResponseStatus;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;

import java.io.IOException;

import static org.xbib.j2html.TagCreator.body;
import static org.xbib.j2html.TagCreator.h1;
import static org.xbib.j2html.TagCreator.html;

public class NotFoundHandler extends J2HtmlResourceHandler {

    public NotFoundHandler() {
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return new UnauthorizedResource(this, httpRouterContext);
    }

    protected static class UnauthorizedResource extends J2HtmlResource {

        protected UnauthorizedResource(HtmlTemplateResourceHandler templateResourceHandler,
                                       HttpRouterContext httpRouterContext)
                throws IOException, ParameterException {
            super(templateResourceHandler, httpRouterContext);
        }

        @Override
        protected HttpResponseStatus getResponseStatus() {
            return HttpResponseStatus.NOT_FOUND;
        }

        @Override
        protected String renderHtml(HttpRouterContext httpRouterContext) {
            return html(body(h1("Not found"))).render();
        }
    }
}
