package org.xbib.net.http.server.application.config;

import org.xbib.config.ConfigLoader;
import org.xbib.config.ConfigParams;
import org.xbib.net.http.server.HttpRequest;
import org.xbib.net.http.server.application.Application;
import org.xbib.net.http.server.application.BaseApplicationModule;
import org.xbib.net.http.server.route.HttpRouterContext;
import org.xbib.net.http.server.service.HttpService;
import org.xbib.settings.Settings;

public class ConfigApplicationModule extends BaseApplicationModule {

    private final ConfigParams configParams;

    private final ConfigLoader configLoader;

    private final Settings settings;

    public ConfigApplicationModule(Application application, String name) {
        super(application, name);
        String profile = application.getProfile();
        if (profile == null) {
            profile = "dev";
        }
        this.configParams = new ConfigParams()
                .withDirectoryName(name)
                .withFileNamesWithoutSuffix(profile)
                .withSystemEnvironment()
                .withSystemProperties();
        this.configLoader = ConfigLoader.getInstance();
        this.settings = configLoader.load(configParams);
    }

    @Override
    public void onOpen(HttpRouterContext httpRouterContext, HttpService httpService, HttpRequest httpRequest) {
        httpRouterContext.getAttributes().put("configparams", configParams);
        httpRouterContext.getAttributes().put("configloader", configLoader);
        httpRouterContext.getAttributes().put("settings", settings);
    }
}
