package org.xbib.net.http.server.resource;

import java.io.IOException;
import java.nio.file.Path;

import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.server.route.HttpRouterContext;

public class HtmlTemplateResourceHandler extends AbstractResourceHandler {

    protected final Path root;

    protected final String suffix;

    protected final String indexFileName;

    public HtmlTemplateResourceHandler(Path root,
                                       String suffix,
                                       String indexFileName) {
        this.root = root;
        this.suffix = suffix;
        this.indexFileName = indexFileName;
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return new HtmlTemplateResource(this, httpRouterContext);
    }

    @Override
    protected boolean isETagEnabled() {
        return false;
    }

    @Override
    protected boolean isRangeEnabled() {
        return false;
    }

    @Override
    protected int getCacheMaxAgeSeconds() {
        // disables caching
        return 0;
    }

    @Override
    protected String getCacheControl() {
        return "no-cache";
    }

    public Path getRoot() {
        return root;
    }

    public String getSuffix() {
        return suffix;
    }

    public String getIndexFileName() {
        return indexFileName;
    }
}
