package org.xbib.net.http.server.test.base;

import org.junit.jupiter.api.Test;
import org.xbib.net.http.server.domain.HttpDomain;
import org.xbib.net.http.server.route.BaseHttpRouter;
import org.xbib.net.http.server.route.HttpRouter;
import org.xbib.settings.Settings;

import java.util.Optional;

import static org.junit.jupiter.api.Assertions.assertTrue;

public class RouterBuilderTest {

    public RouterBuilderTest() {
    }

    @Test
    void buildFromSettings() {
        // the simplest possible setup in settings
        Settings settings = Settings.settingsBuilder()
                .put("domain.domain1.name", "localhost")
                .put("domain.domain1.service./demo1.method", "GET")
                .put("domain.domain1.service./demo1.class", "org.xbib.net.http.server.handler.OkHandler")
                .build();
        HttpRouter httpRouter = BaseHttpRouter.builder()
                .fromSettings(settings)
                .build();
        Optional<HttpDomain> httpDomain = httpRouter.getDomains().stream().findFirst();
        assertTrue(httpDomain.isPresent());
        assertTrue(httpDomain.get().getNames().contains("localhost"));
    }
}
