package org.xbib.net.http.server.test.userprofile;

import org.junit.jupiter.api.Test;
import org.xbib.datastructures.json.tiny.JsonBuilder;
import org.xbib.net.UserProfile;
import org.xbib.net.http.server.persist.Codec;
import org.xbib.net.http.server.auth.FileJsonUserProfileCodec;

import java.io.IOException;
import java.nio.file.Paths;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class JsonUserProfileTest {

    public JsonUserProfileTest() {
    }

    @Test
    void testJsonUserProfile() throws IOException {
        Codec<UserProfile> userProfileCodec = newUserProfileCodec();
        UserProfile userProfile = create(userProfileCodec);
        userProfile.getAttributes().put("a", "b");
        userProfileCodec.write(userProfile.getUserId(), userProfile);
        UserProfile userProfile1 = userProfileCodec.read(userProfile.getUserId());
        assertEquals("b", userProfile1.getAttributes().get("a").toString());
        userProfileCodec.destroy();
    }

    private Codec<UserProfile> newUserProfileCodec() {
        return new FileJsonUserProfileCodec(Paths.get("build/userprofile-test"));
    }

    private UserProfile create(Codec<UserProfile> userProfileCodec) throws IOException {
        return userProfileCodec.create("1");
    }
}
